"use strict";
// -*- mode: typescript; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of ThingTalk
//
// Copyright 2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
Object.defineProperty(exports, "__esModule", { value: true });
exports.isRemoteSend = exports.isRemoteReceive = void 0;
const invocation_1 = require("./invocation");
function isRemoteReceive(fn) {
    return (fn.selector instanceof invocation_1.DeviceSelector &&
        (fn.selector.kind === 'org.thingpedia.builtin.thingengine.remote' || fn.selector.kind.startsWith('__dyn_'))
        && fn.channel === 'receive');
}
exports.isRemoteReceive = isRemoteReceive;
function isRemoteSend(fn) {
    return (fn.selector instanceof invocation_1.DeviceSelector &&
        (fn.selector.kind === 'org.thingpedia.builtin.thingengine.remote' || fn.selector.kind.startsWith('__dyn_'))
        && fn.channel === 'send');
}
exports.isRemoteSend = isRemoteSend;
//# sourceMappingURL=remote_utils.js.map