import AsyncQueue from 'consumer-queue';
import type { ExecEnvironment } from './exec_environment';
interface MonitorTupleLike {
    __timestamp: number;
}
export declare function isNewTuple<T extends MonitorTupleLike, K extends keyof T>(state: T[] | null, tuple: T, keys: K[]): boolean;
export declare function addTuple<T extends MonitorTupleLike>(state: T[] | null, tuple: T): T[];
declare type ResultT<T> = [string, T];
declare type EmitFunction<T> = (type: string, value: T) => void;
declare type Stream<T> = (emit: EmitFunction<T>) => Promise<void>;
export declare function streamUnion<T>(lhs: Stream<T>, rhs: Stream<T>): AsyncIterator<ResultT<T>>;
export declare function tableJoin<T1, T2>(lhs: Stream<T1>, rhs: Stream<T2>): AsyncIterator<ResultT<T1 & T2>, void>;
export declare function tableCrossJoin<T>(lhs: Stream<T>, rhs: Stream<T>): AsyncIterator<ResultT<T>, void>;
declare type StreamFunction<T> = (env: ExecEnvironment, emit: EmitFunction<T>, ...args: any[]) => Promise<void>;
export declare function invokeStreamVarRef<T>(env: ExecEnvironment, varref: StreamFunction<T>, ...args: any[]): AsyncQueue<IteratorResult<ResultT<T>, void>>;
interface IterableOrAsyncIterable<T> {
    [Symbol.iterator]?: () => Iterator<T>;
    [Symbol.asyncIterator]?: () => AsyncIterator<T>;
}
export declare function getAsyncIterator<T>(obj: IterableOrAsyncIterable<T>): Iterator<T> | AsyncIterator<T>;
export {};
